<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F20000 - Dice History</h2>
    </div>
    <div class="jumbotron container">
      <div>
        <label><b>Player's information:</b></label>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
            <label>Username </label> &nbsp
            <input id="inp-username" placeholder="input username" class="btn-primary" style="color:aliceblue" > 
        </div>
        <div class="col-sm-4">
          <label>Firstname </label> &nbsp
          <input id="inp-firstname" placeholder="input firstname" class="bg-primary" style="color:aliceblue">
      </div>
     
      <div class="col-sm-4">
        <label>Lastname </label> &nbsp
        <input id="inp-lastname" placeholder="input lastname" class="bg-primary" style="color:aliceblue" >
    </div>
   
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead class="text-center thead-dark">
          <tr>
            <th>Game</th>
            <th>Dice</th>
          </tr>
        </thead>
      </table>
    </div>
    
</body>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

  var gPlayerInfoObj = {};
  var gDiceHistoryData = [];

  //set table for loading data
  const gTABLE_COLs = ["game", "dice"];

  //set columns
  const gSTT_COL = 0;
  const gDICES_COL = 1;
  
  //mapping columns and load data to the table
  var vDiceTable = $("#user-table").DataTable({
      columns: [
        {data: gTABLE_COLs[gSTT_COL]},
        {data: gTABLE_COLs[gDICES_COL]},
      ],
      columnDefs: [
        {
          targets: gSTT_COL,
          className: 'text-center',
        },
        {
          targets: gDICES_COL,
          className: 'text-center',
        },
      ]
    });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading()

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  
  function onPageLoading(){

    var vCurrent = window.location.href;
    getDataFromQueryString(vCurrent);
    loadPlayerInfoToForm(gPlayerInfoObj)
    callApiByUsername(gPlayerInfoObj.username)
    
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
  //function for getting query string
  function getDataFromQueryString(paramUrl){
   
    //get the parameters
    var vUrl = new URL(paramUrl);
    var vUsername = vUrl.searchParams.get("username");
    var vFirstname = vUrl.searchParams.get("firstname");
    var vLastname = vUrl.searchParams.get("lastname");
    
    gPlayerInfoObj.username = vUsername;
    gPlayerInfoObj.firstname = vFirstname;
    gPlayerInfoObj.lastname = vLastname;
      console.log("%cUsername: ","color:orange", gPlayerInfoObj);

   }

  //function for calling API by username
  function callApiByUsername(paramUsername){
          
    //console.log("%cparam-username: ", "color:orange", paramUsername);
    const baseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice";

    $.ajax({
      url: baseUrl + "/dice-history?username=" + paramUsername,
      type:"GET",
      success: function(res){
        console.log("%cDICE History: ", "color:orange", res);
        if (res.dices.length >0){
          //console.log("%cDICE History: ", "color:orange", res.dices[0]);
          var vCount = 0;
          while (vCount < res.dices.length){
            var bDice = {'game': vCount +1, 'dice': res.dices[vCount]};
            gDiceHistoryData.push(bDice);
            vCount++
          }
        }
        loadDataToTable(gDiceHistoryData);
      },
      error: function(ajaxContext){
        console.log(ajaxContext.status);
      }
    });
  }
 
  //load data to the table
  function loadDataToTable(paramData){
    console.log("%cDICE History: ", "color:orange", paramData);
    vDiceTable.clear(); 
    vDiceTable.rows.add(paramData); 
    vDiceTable.draw(); 
  }

  //load player's info to the form
  function loadPlayerInfoToForm(paramInfo){
    $("#inp-username").val(paramInfo.username);
    $("#inp-firstname").val(paramInfo.firstname);
    $("#inp-lastname").val(paramInfo.lastname);
  }  

</script>

</html>